import { IPublicHostedZone } from 'aws-cdk-lib/aws-route53';
import { Construct } from 'constructs';
export interface ICrossRegionAccountSubZoneConfig {
    readonly primary: boolean;
    readonly primaryRegion: string;
    readonly secondaryRegion: string;
    readonly cicdAccount?: string;
}
export declare class CrossRegionAccountSubZone extends Construct {
    protected parentZoneName: string;
    protected parentZoneId: string;
    constructor(scope: Construct, id: string, parentZoneName: string, parentZoneId: string);
    setupCommon(accounts: string[], intermediateZonePrefix: string): void;
    setupDns(envName: string, config: ICrossRegionAccountSubZoneConfig): IPublicHostedZone;
}
